/* $LAAS$ */
/*
 * Copyright (c) 1996-2006 CNRS/LAAS
 *
 * Permission to use, copy, modify, and distribute this software for any
 * purpose with or without fee is hereby granted, provided that the above
 * copyright notice and this permission notice appear in all copies.
 *
 * THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
 * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
 * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
 * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
 * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
 * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 */
/**
 ** demoCntrlTaskCodels.c
 **
 ** Codels used by the control task demoCntrlTask
 **
 ** Auteur: 
 ** Date: 
 **
 **/

#include <stdio.h>

#include <portLib.h>

#include "server/demoHeader.h"
#include "demoConst.h"

/*------------------------------------------------------------------------
 * controlSpeed  -  control codel of request ChangerSpeed
 *
 * Report: OK 
 *         S_demo_INVALID_SPEED
 *
 * Return:    OK ou ERROR
 */

STATUS controlSpeed (DEMO_SPEED *speedRef, int *bilan)
{

  if(*speedRef != DEMO_SLOW && *speedRef != DEMO_FAST) {
    *bilan = S_demo_INVALID_SPEED;
    return ERROR;
  }

  return OK;
}

/*------------------------------------------------------------------------
 * controlPosition  -  control codel of request Deplacer
 *
 * Description:    
 * Report (bilan): OK 
 *                 S_demo_TOO_FAR_AWAY
 *
 * Return:    OK ou ERROR
 */

STATUS controlPosition (double *posRef, int *bilan)
{
  if (*posRef > DEMO_MACHINE_LENGTH/2 || *posRef < -DEMO_MACHINE_LENGTH/2) {
    *bilan = S_demo_TOO_FAR_AWAY;
    return ERROR;
  }
  return OK;
}

/*------------------------------------------------------------------------
 * controlDistance  -  control codel of request Deplacer
 *
 * Description:    
 * Report (bilan): OK 
 *                 S_demo_TOO_FAR_AWAY
 *
 * Return:    OK ou ERROR
 */

STATUS controlDistance (double *distRef, int *bilan)
{
  double posRef;

  posRef = SDI_F->state.position + *distRef;
  if(controlPosition(&posRef, bilan) == ERROR)
    return ERROR;

  SDI_F->posRef = posRef;

  return OK;
}


/*------------------------------------------------------------------------
 * controlMonPos  -  control codel of request Monitor
 *
 * Description:    
 * Report (bilan): OK 
 *                 S_demo_TOO_FAR_AWAY
 *
 * Return:    OK ou ERROR
 */
STATUS controlMonPos (double *posRef, int *bilan)
{

  if (controlPosition(posRef, bilan) == ERROR)
    return ERROR;

  return OK;
}


