/* $LAAS$ */
/*
 * Copyright (c) 1996-2006 CNRS/LAAS
 *
 * Permission to use, copy, modify, and distribute this software for any
 * purpose with or without fee is hereby granted, provided that the above
 * copyright notice and this permission notice appear in all copies.
 *
 * THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
 * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
 * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
 * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
 * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
 * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 */
/**
 ** demoMotionTaskCodels.c
 **
 ** Codels called by execution task demoMotionTask
 **
 ** Author: 
 ** Date: 
 **
 **/

#include <stdio.h>
#include <math.h>

#include <portLib.h>

#include "h2mathLib.h"
#include "server/demoHeader.h"
#include "demoConst.h"

/*#define SIGN(x) ((x)<0.?-1.0:1.0)*/


/*------------------------------------------------------------------------
 *
 * InitDemoSDI  --  Initialization codel (fIDS, ...)
 *
 * Description: 
 * 
 * Returns:    OK or ERROR
 */

STATUS InitDemoSDI(int *bilan)
{
  SDI_F->state.position = 0.;
  SDI_F->state.speed = 0;
  SDI_F->distRef = 0;
  SDI_F->posRef = 0;
  SDI_F->speedRef = DEMO_SLOW;

  return OK;
}

/*------------------------------------------------------------------------
 * MoveDistance
 *
 * Description: 
 *
 * Reports:      OK
 *              S_demo_TOO_FAR_AWAY
 */


/* startEngine  -  codel START of MoveDistance
   Returns:  START EXEC END ETHER FAIL ZOMBIE */
ACTIVITY_EVENT startEngine (double *distRef, int *bilan)
{
  printf ("start engine\n");
  return EXEC;
}

/* gotoPosition  -  codel EXEC of MoveDistance
   Returns:  EXEC END ETHER FAIL ZOMBIE */
ACTIVITY_EVENT gotoPosition (double *posRef, int *bilan)
{
  double distRemain;
  double dDist;
  double v;

  distRemain = SDI_F->posRef - SDI_F->state.position;
  v = SDI_F->speedRef == DEMO_SLOW ? DEMO_DEFAULT_MAX_SPEED/4. : DEMO_DEFAULT_MAX_SPEED;
  dDist = v * EXEC_TASK_PERIOD(DEMO_MOTIONTASK_NUM) * SIGN(distRemain);

  if (fabs(distRemain) < fabs(dDist)) {
    SDI_F->state.position = SDI_F->posRef;
    SDI_F->state.speed = 0;
    return END;
  }
  SDI_F->state.position += dDist;
  SDI_F->state.speed = v;
#ifdef VERBOSE
  printf ("speed %g m/s  pos %g m\n", v, SDI_F->state.position);
#endif
  return EXEC;
}

/* stopEngine  -  codel END of MoveDistance
   Returns:  END ETHER FAIL ZOMBIE */
ACTIVITY_EVENT stopEngine (double *distRef, int *bilan)
{
#ifdef VERBOSE
  printf ("speed %g m/s  pos %g m\n", SDI_F->state.speed, SDI_F->state.position);
#endif
  printf ("stop engine\n");
  return ETHER;
}

/*------------------------------------------------------------------------
 * Monitor
 *
 * Description: 
 *
 * Reports:      OK
 *              S_demo_TOO_FAR_AWAY
 */

/* monitor  -  codel EXEC of Monitor
   Returns:  EXEC END ETHER FAIL ZOMBIE */
ACTIVITY_EVENT monitor (double *mon, double *pos, int *bilan)
{
  double dDist;

  dDist = SDI_F->state.speed * EXEC_TASK_PERIOD(DEMO_MOTIONTASK_NUM);
  *pos = SDI_F->state.position;
  if (fabs (*mon - *pos) < dDist) {
    printf ("dist %f mon %f pos %f\n", dDist, *mon, *pos);
    return ETHER;
  }
  return EXEC;
}


